diff --git a/tests/test_commands.py b/tests/test_commands.py
index 36321e2..9eb12fa 100644
--- a/tests/test_commands.py
+++ b/tests/test_commands.py
@@ -5,11 +5,9 @@ import io
 import os
 import shutil
 import six
-import subprocess
 import tempfile
 
 import git
-import rpm
 from mock import call
 from mock import patch
 from mock import Mock
@@ -21,181 +19,6 @@ from pyrpkg import rpkgError
 from utils import CommandTestCase
 
 
-def mock_load_rpmdefines(self):
-    """Mock Commands.load_rpmdefines by setting empty list to _rpmdefines
-
-    :param Commands self: load_rpmdefines is an instance method of Commands,
-    self is the instance whish is calling this method.
-    """
-    self._rpmdefines = []
-
-
-def mock_load_spec(fake_spec):
-    """Return a mocked load_spec method that sets a fake spec to Commands
-
-    :param str fake_spec: an arbitrary string representing a fake spec
-    file. What value is passed to fake_spec depends on the test purpose
-    completely.
-    """
-    def mocked_load_spec(self):
-        """Mocked load_spec to set fake spec to an instance of Commands
-
-        :param Commands self: load_spec is an instance method of Commands, self
-        is the instance which is calling this method.
-        """
-        self._spec = fake_spec
-    return mocked_load_spec
-
-
-class LoadNameVerRelTest(CommandTestCase):
-    """Test case for Commands.load_nameverrel"""
-
-    def setUp(self):
-        super(LoadNameVerRelTest, self).setUp()
-        self.cmd = self.make_commands()
-        self.checkout_branch(self.cmd.repo, 'eng-rhel-6')
-        self.tempdir = tempfile.mkdtemp(prefix='rpkg_test_')
-
-    def tearDown(self):
-        super(LoadNameVerRelTest, self).tearDown()
-        shutil.rmtree(self.tempdir)
-
-    def test_load_from_spec(self):
-        """Ensure name, version, release can be loaded from a valid SPEC"""
-        self.cmd.load_nameverrel()
-        self.assertEqual('docpkg', self.cmd._package_name_spec)
-        self.assertEqual('0', self.cmd._epoch)
-        self.assertEqual('1.2', self.cmd._ver)
-        self.assertEqual('2.el6', self.cmd._rel)
-
-    def test_load_spec_where_path_contains_space(self):
-        """Ensure load_nameverrel works with a repo whose path contains space
-
-        This test aims to test the space appearing in path does not break rpm
-        command execution.
-
-        For this test purpose, firstly, original repo has to be cloned to a
-        new place which has a name containing arbitrary spaces.
-        """
-        cloned_repo_dir = os.path.join(self.tempdir, 'rpkg test cloned repo')
-        if os.path.exists(cloned_repo_dir):
-            shutil.rmtree(cloned_repo_dir)
-        cloned_repo = self.cmd.repo.repo.clone(cloned_repo_dir)
-
-        # Switching to branch eng-rhel-6 explicitly is required by running this
-        # on RHEL6/7 because an old version of git is available in the
-        # repo.
-        # The failure reason is, old version of git makes the master as the
-        # active branch in cloned repository, whatever the current active
-        # branch is in the remote repository.
-        # As of fixing this, I ran test on Fedora 23 with git 2.5.5, and test
-        # fails on RHEL7 with git 1.8.3.1
-        cloned_repo.git.checkout('eng-rhel-6')
-
-        cmd = self.make_commands(path=cloned_repo_dir)
-
-        cmd.load_nameverrel()
-        self.assertEqual('docpkg', cmd._package_name_spec)
-        self.assertEqual('0', cmd._epoch)
-        self.assertEqual('1.2', cmd._ver)
-        self.assertEqual('2.el6', cmd._rel)
-
-    @patch('pyrpkg.Commands.load_rpmdefines', new=mock_load_rpmdefines)
-    @patch('pyrpkg.Commands.load_spec',
-           new=mock_load_spec('unknown-rpm-option a-nonexistent-package.spec'))
-    def test_load_when_rpm_fails(self):
-        """Ensure rpkgError is raised when rpm command fails
-
-        Commands.load_spec is mocked to help generate an incorrect rpm command
-        line to cause the error that this test expects.
-
-        Test test does not care about what rpm defines are retrieved from
-        repository, so setting an empty list to Commands._rpmdefines is safe
-        and enough.
-        """
-        self.assertRaises(rpkgError, self.cmd.load_nameverrel)
-
-    def test_load_when_echo_text_from_spec(self):
-        import utils
-        self.write_file(os.path.join(self.cloned_repo_path, self.spec_file),
-                        content=utils.spec_file_echo_text)
-
-        self.cmd.load_nameverrel()
-        self.assertEqual('docpkg', self.cmd._package_name_spec)
-        self.assertEqual('0', self.cmd._epoch)
-        self.assertEqual('1.2', self.cmd._ver)
-        self.assertEqual('2.el6', self.cmd._rel)
-
-
-class LoadRPMDefinesTest(CommandTestCase):
-    """Test case for Commands.load_rpmdefines"""
-
-    def setUp(self):
-        super(LoadRPMDefinesTest, self).setUp()
-        self.cmd = self.make_commands()
-
-    def assert_loaded_rpmdefines(self, branch_name, expected_defines):
-        self.checkout_branch(self.cmd.repo, branch_name)
-
-        self.cmd.load_rpmdefines()
-        self.assertTrue(self.cmd._rpmdefines)
-
-        # Convert defines into dict for assertion conveniently. The dict
-        # contains mapping from variable name to value. For example,
-        # {
-        #     '_sourcedir': '/path/to/src-dir',
-        #     '_specdir': '/path/to/spec',
-        #     '_builddir': '/path/to/build-dir',
-        #     '_srcrpmdir': '/path/to/srcrpm-dir',
-        #     'dist': 'el7'
-        # }
-        defines = dict([item.split(' ') for item in (
-            define.replace("'", '').split(' ', 1)[1] for
-            define in self.cmd._rpmdefines)])
-
-        for var, val in expected_defines.items():
-            self.assertTrue(var in defines)
-            self.assertEqual(val, defines[var])
-
-    def test_load_rpmdefines_from_eng_rhel_6(self):
-        """Run load_rpmdefines against branch eng-rhel-6"""
-        expected_rpmdefines = {
-            '_sourcedir': self.cloned_repo_path,
-            '_specdir': self.cloned_repo_path,
-            '_builddir': self.cloned_repo_path,
-            '_srcrpmdir': self.cloned_repo_path,
-            '_rpmdir': self.cloned_repo_path,
-            'dist': u'.el6',
-            'rhel': u'6',
-            'el6': u'1',
-            }
-        self.assert_loaded_rpmdefines('eng-rhel-6', expected_rpmdefines)
-
-    def test_load_rpmdefines_from_eng_rhel_6_5(self):
-        """Run load_rpmdefines against branch eng-rhel-6.5
-
-        Working on a different branch name is the only difference from test
-        method test_load_rpmdefines_from_eng_rhel_6.
-        """
-        expected_rpmdefines = {
-            '_sourcedir': self.cloned_repo_path,
-            '_specdir': self.cloned_repo_path,
-            '_builddir': self.cloned_repo_path,
-            '_srcrpmdir': self.cloned_repo_path,
-            '_rpmdir': self.cloned_repo_path,
-            'dist': u'.el6_5',
-            'rhel': u'6',
-            'el6_5': u'1',
-            }
-        self.assert_loaded_rpmdefines('eng-rhel-6.5', expected_rpmdefines)
-
-    @patch('pyrpkg.pkgrepo.PackageRepository.branch_merge', new_callable=PropertyMock)
-    def test_load_rpmdefines_against_invalid_branch(self, branch_merge):
-        branch_merge.return_value = 'invalid-branch-name'
-
-        self.assertRaises(rpkgError, self.cmd.load_rpmdefines)
-
-
 class CheckRepoWithOrWithoutDistOptionCase(CommandTestCase):
     """Check whether there are unpushed changes with or without specified dist
 
@@ -293,117 +116,6 @@ $what_is_this
         self.assertEqual(expected_lines, clog_lines)
 
 
-class TestProperties(CommandTestCase):
-
-    def setUp(self):
-        super(TestProperties, self).setUp()
-        self.invalid_repo = tempfile.mkdtemp()
-
-    def tearDown(self):
-        shutil.rmtree(self.invalid_repo)
-        super(TestProperties, self).tearDown()
-
-    def test_target(self):
-        cmd = self.make_commands()
-        self.checkout_branch(cmd.repo, 'eng-rhel-6')
-        self.assertEqual('eng-rhel-6-candidate', cmd.target)
-
-    def test_spec(self):
-        cmd = self.make_commands()
-        self.assertEqual('docpkg.spec', cmd.spec)
-
-    def test_no_spec_as_it_is_deadpackage(self):
-        with patch('os.listdir', return_value=['dead.package']):
-            cmd = self.make_commands()
-            self.assertRaises(rpkgError, cmd.load_spec)
-
-    def test_no_spec_there(self):
-        with patch('os.listdir', return_value=['anyfile']):
-            cmd = self.make_commands()
-            self.assertRaises(rpkgError, cmd.load_spec)
-
-    def test_nvr(self):
-        cmd = self.make_commands(dist='eng-rhel-6')
-
-        module_name = os.path.basename(self.repo_path)
-        self.assertEqual('{0}-1.2-2.el6'.format(module_name), cmd.nvr)
-
-    def test_nvr_cannot_get_module_name_from_push_url(self):
-        cmd = self.make_commands(path=self.repo_path, dist='eng-rhel-6')
-        self.assertEqual('docpkg-1.2-2.el6', cmd.nvr)
-
-    def test_localarch(self):
-        expected_localarch = rpm.expandMacro('%{_arch}')
-        cmd = self.make_commands()
-        self.assertEqual(expected_localarch, cmd.localarch)
-
-    def test_commithash(self):
-        cmd = self.make_commands(path=self.cloned_repo_path)
-        repo = git.Repo(self.cloned_repo_path)
-        expected_commit_hash = str(six.next(repo.iter_commits()))
-        self.assertEqual(expected_commit_hash, cmd.repo.commit_hash)
-
-    def test_dist(self):
-        repo = git.Repo(self.cloned_repo_path)
-        self.checkout_branch(repo, 'eng-rhel-7')
-
-        cmd = self.make_commands(path=self.cloned_repo_path)
-        self.assertEqual('el7', cmd.disttag)
-        self.assertEqual('rhel', cmd.distvar)
-        self.assertEqual('7', cmd.distval)
-        self.assertEqual('0', cmd.epoch)
-
-    def test_repo(self):
-        cmd = self.make_commands(path=self.cloned_repo_path)
-        cmd.load_repo()
-        self.assertEqual(self.cloned_repo_path, os.path.dirname(cmd._repo.git_dir))
-
-        cmd = self.make_commands(path=self.invalid_repo)
-        self.assertRaises(rpkgError, cmd.load_repo)
-
-        cmd = self.make_commands(path='some-dir')
-        self.assertRaises(rpkgError, cmd.load_repo)
-
-    def test_mockconfig(self):
-        cmd = self.make_commands(path=self.cloned_repo_path)
-        self.checkout_branch(cmd.repo, 'eng-rhel-7')
-        expected_localarch = rpm.expandMacro('%{_arch}')
-        self.assertEqual('eng-rhel-7-candidate-{0}'.format(expected_localarch),
-                         cmd.mockconfig)
-
-    def test_get_ns_module_name(self):
-        tests = (
-            ('http://localhost/rpms/docpkg.git', 'docpkg'),
-            ('http://localhost/docker/docpkg.git', 'docpkg'),
-            ('http://localhost/docpkg.git', 'docpkg'),
-            ('http://localhost/rpms/docpkg', 'docpkg'),
-            )
-        for push_url, expected_ns_module_name in tests:
-            with patch('pyrpkg.pkgrepo.PackageRepository.push_url',
-                       new_callable=PropertyMock,
-                       return_value=push_url):
-                cmd = self.make_commands(path=self.cloned_repo_path)
-                cmd.load_ns()
-                cmd.load_module_name()
-                self.assertEqual(expected_ns_module_name, cmd.ns_module_name)
-
-        tests = (
-            ('http://localhost/rpms/docpkg.git', 'rpms/docpkg'),
-            ('http://localhost/docker/docpkg.git', 'docker/docpkg'),
-            ('http://localhost/docpkg.git', 'rpms/docpkg'),
-            ('http://localhost/rpms/docpkg', 'rpms/docpkg'),
-            )
-        for push_url, expected_ns_module_name in tests:
-            with patch('pyrpkg.pkgrepo.PackageRepository.push_url',
-                       new_callable=PropertyMock,
-                       return_value=push_url):
-                cmd = self.make_commands(path=self.cloned_repo_path)
-                cmd.distgit_namespaced = True
-                cmd.load_ns()
-                cmd.load_module_name()
-                self.assertEqual(expected_ns_module_name, cmd.ns_module_name)
-
-
 class TestNamespaced(CommandTestCase):
 
     def test_get_namespace_giturl(self):
@@ -505,28 +217,6 @@ class TestTagInheritanceTag(CommandTestCase):
         self.assertRaises(rpkgError, cmd.check_inheritance, build_target, dest_tag)
 
 
-class TestLoadModuleNameFromSpecialPushURL(CommandTestCase):
-    """Test load module name from a special push url that ends in /
-
-    For issue: https://pagure.io/rpkg/issue/192
-    """
-
-    def setUp(self):
-        super(TestLoadModuleNameFromSpecialPushURL, self).setUp()
-
-        self.case_repo = tempfile.mkdtemp(prefix='case-test-load-module-name-')
-        cmd = ['git', 'clone', '{0}/'.format(self.repo_path), self.case_repo]
-        self.run_cmd(cmd, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
-
-    def tearDown(self):
-        shutil.rmtree(self.case_repo)
-        super(TestLoadModuleNameFromSpecialPushURL, self).tearDown()
-
-    def test_load_module_name(self):
-        cmd = self.make_commands(path=self.case_repo)
-        self.assertEqual(os.path.basename(self.repo_path), cmd.module_name)
-
-
 class TestLoginKojiSession(CommandTestCase):
     """Test login_koji_session"""
 
@@ -620,7 +310,7 @@ class TestLoginKojiSession(CommandTestCase):
 class TestConstructBuildURL(CommandTestCase):
     """Test Commands.construct_build_url"""
 
-    @patch('pyrpkg.Commands.ns_repo_name', new_callable=PropertyMock)
+    @patch('pyrpkg.PackageMetadata.ns_repo_name', new_callable=PropertyMock)
     @patch('pyrpkg.PackageRepository.commit_hash', new_callable=PropertyMock)
     def test_construct_url(self, commit_hash, ns_module_name):
         commit_hash.return_value = '12345'
@@ -702,7 +392,7 @@ class TestConfigMockConfigDir(CommandTestCase):
 
         self.fake_root = 'fedora-26-x86_64'
         self.mock_config_patcher = patch('pyrpkg.Commands.mock_config',
-                                         return_value='mock config x86_64')
+                                         return_value=u'mock config x86_64')
         self.mock_mock_config = self.mock_config_patcher.start()
 
         self.mkdtemp_patcher = patch('tempfile.mkdtemp',
@@ -739,7 +429,8 @@ class TestConfigMockConfigDir(CommandTestCase):
             self.assertEqual(self.mock_mock_config.return_value,
                              f.read().strip())
 
-    @patch('pyrpkg.Commands.mockconfig', new_callable=PropertyMock)
+    @patch('pyrpkg.pkginfo.PackageMetadata.mockconfig',
+           new_callable=PropertyMock)
     def test_config_using_root_guessed_from_branch(self, mockconfig):
         mockconfig.return_value = 'f26-candidate-i686'
 
@@ -845,13 +536,18 @@ class TestConfigMockConfigDirWithNecessaryFiles(CommandTestCase):
 
 
 class TestLint(CommandTestCase):
+
     @patch('glob.glob')
     @patch('os.path.exists')
     @patch('pyrpkg.Commands._run_command')
-    @patch('pyrpkg.Commands.load_rpmdefines', new=mock_load_rpmdefines)
-    @patch('pyrpkg.Commands.rel', new_callable=PropertyMock)
-    def test_lint_each_file_once(self, rel, run, exists, glob):
+    @patch('pyrpkg.PackageMetadata.repo_name', new_callable=PropertyMock)
+    @patch('pyrpkg.PackageMetadata.rpmdefines', new_callable=PropertyMock)
+    @patch('pyrpkg.PackageMetadata.rel', new_callable=PropertyMock)
+    def test_lint_each_file_once(
+            self, rel, rpmdefines, module_name, run, exists, glob):
         rel.return_value = '2.fc26'
+        rpmdefines.return_value = []
+        module_name.return_value = 'docpkg'
 
         cmd = self.make_commands()
         srpm_path = os.path.join(cmd.path, 'docpkg-1.2-2.fc26.src.rpm')
@@ -861,6 +557,10 @@ class TestLint(CommandTestCase):
             return path in [
                 srpm_path,
                 os.path.join(cmd.path, 'x86_64'),
+
+                # For checking existence of repo directory when visit property
+                # self.repo
+                self.cloned_repo_path,
             ]
 
         def _mock_glob(g):
diff --git a/tests/test_pkg_metadata.py b/tests/test_pkg_metadata.py
new file mode 100644
index 0000000..0bf4164
--- /dev/null
+++ b/tests/test_pkg_metadata.py
@@ -0,0 +1,269 @@
+# -*- coding: utf-8 -*-
+
+import os
+import rpm
+import shutil
+import subprocess
+import tempfile
+
+from mock import patch, PropertyMock
+from utils import CommandTestCase
+from pyrpkg.errors import rpkgError
+from pyrpkg.pkginfo import PackageMetadata
+from pyrpkg.pkgrepo import PackageRepository
+
+
+class TestProperties(CommandTestCase):
+    """Test various package properties"""
+
+    def setUp(self):
+        super(TestProperties, self).setUp()
+        self.repo = PackageRepository(self.cloned_repo_path)
+        self.package = PackageMetadata(self.repo)
+        self.invalid_repo = tempfile.mkdtemp()
+
+    def tearDown(self):
+        shutil.rmtree(self.invalid_repo)
+        super(TestProperties, self).tearDown()
+
+    def test_target(self):
+        self.repo.git.checkout('eng-rhel-6')
+        self.assertEqual('eng-rhel-6-candidate', self.package.target)
+
+    def test_spec(self):
+        self.assertEqual('docpkg.spec', self.package.spec)
+
+    def test_no_spec_as_it_is_deadpackage(self):
+        with patch('os.listdir', return_value=['dead.package']):
+            self.assertRaises(rpkgError, self.package.load_spec)
+
+    def test_no_spec_there(self):
+        with patch('os.listdir', return_value=['anyfile']):
+            self.assertRaises(rpkgError, self.package.load_spec)
+
+    def test_nvr(self):
+        repo = PackageRepository(self.cloned_repo_path,
+                                 overwritten_branch_merge='eng-rhel-6')
+        package = PackageMetadata(repo)
+
+        module_name = os.path.basename(self.repo_path)
+        self.assertEqual('{0}-1.2-2.el6'.format(module_name), package.nvr)
+
+    def test_nvr_cannot_get_module_name_from_push_url(self):
+        repo = PackageRepository(self.repo_path,
+                                 overwritten_branch_merge='eng-rhel-6')
+        package = PackageMetadata(repo)
+        self.assertEqual('docpkg-1.2-2.el6', package.nvr)
+
+    def test_localarch(self):
+        expected_localarch = rpm.expandMacro('%{_arch}')
+        self.assertEqual(expected_localarch, self.package.localarch)
+
+
+class TestNamespacedModuleName(CommandTestCase):
+    """Test PackageMetadata.ns_module_name"""
+
+    def setUp(self):
+        super(TestNamespacedModuleName, self).setUp()
+        self.repo = PackageRepository(self.cloned_repo_path)
+
+    def test_distgit_namespaced_is_disabled(self):
+        tests = (
+            ('http://localhost/rpms/docpkg.git', 'docpkg'),
+            ('http://localhost/docker/docpkg.git', 'docpkg'),
+            ('http://localhost/docpkg.git', 'docpkg'),
+            ('http://localhost/rpms/docpkg', 'docpkg'),
+            )
+        for push_url, expected_ns_module_name in tests:
+            with patch('pyrpkg.pkgrepo.PackageRepository.push_url',
+                       new_callable=PropertyMock,
+                       return_value=push_url):
+                package = PackageMetadata(self.repo, distgit_namespaced=False)
+                package.load_ns()
+                package.load_module_name()
+                self.assertEqual(
+                    expected_ns_module_name, package.ns_module_name)
+
+    def test_distgit_namedspaced_is_enabled(self):
+        tests = (
+            ('http://localhost/rpms/docpkg.git', 'rpms/docpkg'),
+            ('http://localhost/docker/docpkg.git', 'docker/docpkg'),
+            ('http://localhost/docpkg.git', 'rpms/docpkg'),
+            ('http://localhost/rpms/docpkg', 'rpms/docpkg'),
+            )
+        for push_url, expected_ns_module_name in tests:
+            with patch('pyrpkg.pkgrepo.PackageRepository.push_url',
+                       new_callable=PropertyMock,
+                       return_value=push_url):
+                package = PackageMetadata(self.repo, distgit_namespaced=True)
+                package.load_ns()
+                package.load_module_name()
+                self.assertEqual(
+                    expected_ns_module_name, package.ns_module_name)
+
+
+class LoadNameVerRelTest(CommandTestCase):
+    """Test case for Commands.load_nameverrel"""
+
+    def setUp(self):
+        super(LoadNameVerRelTest, self).setUp()
+        self.repo = PackageRepository(self.cloned_repo_path)
+        self.package = PackageMetadata(self.repo)
+        self.repo.git.checkout('eng-rhel-6')
+        self.tempdir = tempfile.mkdtemp(prefix='rpkg_test_')
+
+    def tearDown(self):
+        super(LoadNameVerRelTest, self).tearDown()
+        shutil.rmtree(self.tempdir)
+
+    def test_load_from_spec(self):
+        """Ensure name, version, release can be loaded from a valid SPEC"""
+        self.package.load_nameverrel()
+        self.assertEqual('docpkg', self.package._package_name_spec)
+        self.assertEqual('0', self.package._epoch)
+        self.assertEqual('1.2', self.package._ver)
+        self.assertEqual('2.el6', self.package._rel)
+
+    def test_load_spec_where_path_contains_space(self):
+        """Ensure load_nameverrel works with a repo whose path contains space
+
+        This test aims to test the space appearing in path does not break rpm
+        command execution.
+
+        For this test purpose, firstly, original repo has to be cloned to a
+        new place which has a name containing arbitrary spaces.
+        """
+        cloned_repo_dir = os.path.join(self.tempdir, 'rpkg test cloned repo')
+        if os.path.exists(cloned_repo_dir):
+            shutil.rmtree(cloned_repo_dir)
+        cloned_repo = self.repo.repo.clone(cloned_repo_dir)
+
+        # Switching to branch eng-rhel-6 explicitly is required by running this
+        # on RHEL6/7 because an old version of git is available in the
+        # repo.
+        # The failure reason is, old version of git makes the master as the
+        # active branch in cloned repository, whatever the current active
+        # branch is in the remote repository.
+        # As of fixing this, I ran test on Fedora 23 with git 2.5.5, and test
+        # fails on RHEL7 with git 1.8.3.1
+        cloned_repo.git.checkout('eng-rhel-6')
+
+        package = PackageMetadata(PackageRepository(cloned_repo_dir))
+        package.load_nameverrel()
+
+        self.assertEqual('docpkg', package._package_name_spec)
+        self.assertEqual('0', package._epoch)
+        self.assertEqual('1.2', package._ver)
+        self.assertEqual('2.el6', package._rel)
+
+    @patch('pyrpkg.pkginfo.PackageMetadata.rpmdefines', new_callable=PropertyMock)
+    @patch('pyrpkg.pkginfo.PackageMetadata.spec', new_callable=PropertyMock)
+    def test_load_when_rpm_fails(self, spec, rpmdefines):
+        """Ensure rpkgError is raised when rpm command fails
+
+        Commands.load_spec is mocked to help generate an incorrect rpm command
+        line to cause the error that this test expects.
+
+        Test test does not care about what rpm defines are retrieved from
+        repository, so setting an empty list to Commands._rpmdefines is safe
+        and enough.
+        """
+        spec.return_value = 'unknown-rpm-option a-nonexistent-package.spec'
+        # For this test, no need of any rpmdefines
+        rpmdefines.return_value = []
+        self.assertRaises(rpkgError, self.package.load_nameverrel)
+
+
+class LoadRPMDefinesTest(CommandTestCase):
+    """Test case for Commands.load_rpmdefines"""
+
+    def setUp(self):
+        super(LoadRPMDefinesTest, self).setUp()
+        self.package = PackageMetadata(
+            PackageRepository(self.cloned_repo_path))
+
+    def assert_loaded_rpmdefines(self, branch_name, expected_defines):
+        self.package.repo.git.checkout(branch_name)
+
+        self.package.load_rpmdefines()
+        self.assertTrue(self.package._rpmdefines)
+
+        # Convert defines into dict for assertion conveniently. The dict
+        # contains mapping from variable name to value. For example,
+        # {
+        #     '_sourcedir': '/path/to/src-dir',
+        #     '_specdir': '/path/to/spec',
+        #     '_builddir': '/path/to/build-dir',
+        #     '_srcrpmdir': '/path/to/srcrpm-dir',
+        #     'dist': 'el7'
+        # }
+        defines = dict([
+            item.split(' ')
+            for item in (define.replace("'", '').split(' ', 1)[1]
+                         for define in self.package._rpmdefines)
+        ])
+
+        for var, val in expected_defines.items():
+            self.assertTrue(var in defines)
+            self.assertEqual(val, defines[var])
+
+    def test_load_rpmdefines_from_eng_rhel_6(self):
+        """Run load_rpmdefines against branch eng-rhel-6"""
+        expected_rpmdefines = {
+            '_sourcedir': self.cloned_repo_path,
+            '_specdir': self.cloned_repo_path,
+            '_builddir': self.cloned_repo_path,
+            '_srcrpmdir': self.cloned_repo_path,
+            '_rpmdir': self.cloned_repo_path,
+            'dist': u'.el6',
+            'rhel': u'6',
+            'el6': u'1',
+            }
+        self.assert_loaded_rpmdefines('eng-rhel-6', expected_rpmdefines)
+
+    def test_load_rpmdefines_from_eng_rhel_6_5(self):
+        """Run load_rpmdefines against branch eng-rhel-6.5
+
+        Working on a different branch name is the only difference from test
+        method test_load_rpmdefines_from_eng_rhel_6.
+        """
+        expected_rpmdefines = {
+            '_sourcedir': self.cloned_repo_path,
+            '_specdir': self.cloned_repo_path,
+            '_builddir': self.cloned_repo_path,
+            '_srcrpmdir': self.cloned_repo_path,
+            '_rpmdir': self.cloned_repo_path,
+            'dist': u'.el6_5',
+            'rhel': u'6',
+            'el6_5': u'1',
+            }
+        self.assert_loaded_rpmdefines('eng-rhel-6.5', expected_rpmdefines)
+
+    @patch('pyrpkg.pkgrepo.PackageRepository.branch_merge',
+           new_callable=PropertyMock)
+    def test_load_rpmdefines_against_invalid_branch(self, branch_merge):
+        branch_merge.return_value = 'invalid-branch-name'
+        self.assertRaises(rpkgError, self.package.load_rpmdefines)
+
+
+class TestLoadModuleNameFromSpecialPushURL(CommandTestCase):
+    """Test load module name from a special push url that ends in /
+
+    For issue: https://pagure.io/rpkg/issue/192
+    """
+
+    def setUp(self):
+        super(TestLoadModuleNameFromSpecialPushURL, self).setUp()
+
+        self.case_repo = tempfile.mkdtemp(prefix='case-test-load-module-name-')
+        cmd = ['git', 'clone', '{0}/'.format(self.repo_path), self.case_repo]
+        self.run_cmd(cmd, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
+
+    def tearDown(self):
+        shutil.rmtree(self.case_repo)
+        super(TestLoadModuleNameFromSpecialPushURL, self).tearDown()
+
+    def test_load_module_name(self):
+        repo = PackageRepository(self.case_repo)
+        package = PackageMetadata(repo)
+        self.assertEqual(os.path.basename(self.repo_path), package.module_name)
diff --git a/tests/utils.py b/tests/utils.py
index 9403a6a..8779c9a 100644
--- a/tests/utils.py
+++ b/tests/utils.py
@@ -167,7 +167,7 @@ class CommandTestCase(Assertions, Utils, unittest.TestCase):
             ]
         for cmd in git_cmds:
             self.run_cmd(cmd, cwd=self.repo_path,
-                         stdout=subprocess.PIPE, stderr=subprocess.PIPE)
+                         stdout=subprocess.PIPE)
 
         # Clone the repo
         self.cloned_repo_path = tempfile.mkdtemp(prefix='rpkg-commands-tests-cloned-')

